#include "filters.h"

filetype_t getfiletype(char *filename)
{
  char buf[CHUNK];
  short s;
  int fd;
  FILE *fp;
  char command[512];
  char *str;
  int i;

  dprintf("getfiletype(%s)\n",filename);

  fd=open(filename,O_RDONLY);
  if (fd<0)
    {
      perror("open()");
      return(FERROR);
    }
  if (read(fd,buf,2)<0)
    {
      perror("read()");
      return(FERROR);
    }
  if (close(fd)<0) perror("close()");

  memcpy(&s,buf,sizeof(short));

  /*
  ** check the easy magic numbers first
  */
  dprintf("checking easy magic numbers\n");
  if ((buf[0]=='\367') && (buf[1]=='\02'))
    return(FDVI);
  else if ((buf[0]=='%') && (buf[1]=='!'))
    return(FPOSTSCRIPT);
  else if (s == (short)0xffd8)
    return(FJPEG);
  else if (strncmp(buf,"GIF8",4)==0)
    return(FGIF);
  else if ((buf[0]=='M') && (buf[1]=='M') && (buf[2]==0) && (buf[3]==0x2a))
    return(FTIFF);
  else if ((buf[0]=='I') && (buf[1]=='I') && (buf[2]==0x2a) && (buf[3]==0))
    return(FTIFF);
  else if ((buf[0]=='.') && (buf[1]=='\\') && (buf[2]=='"'))
    return(FROFF);
  else if ((buf[0]=='\033') && (buf[1]=='%') && (buf[2]=='-') && (buf[3]=='1'))
    return(FPJL);

  dprintf("WARNING: getfiletype() fell through to using the file command\n");

  /*
  ** now see if the file command can parse it
  */
  sprintf(command,"/usr/bin/file %s",filename);
  fp=popen(command,"r");
  fgets(buf,CHUNK,fp);
  pclose(fp);

  for (i=0;buf[i];i++) buf[i]=tolower(buf[i]);
  str=buf;
  while (*str && *str!=':') str++;

  if (!*str) return(FERROR);

  dprintf("getfiletype(): file command got %s\n",str);

  if (strstr(str,"postscript")) return(FPOSTSCRIPT);
  if (strstr(str,"roff")) return(FROFF);
  if (strstr(str,"dvi")) return(FDVI);
  if (strstr(str,"jpeg")) return(FJPEG);
  if (strstr(str,"gif")) return(FGIF);
  if (strstr(str,"tiff")) return(FTIFF);
  if (strstr(str,"ascii text")) return(FTEXT);
  if (strstr(str,"english text")) return(FTEXT);
  if (strstr(str,"hp printer job language")) return(FPJL);

  dprintf("getfiletype(): fallen through pretty far!  DANGER DANGER!\n");
  if (strstr(str,"text")) return(FTEXT);

  dprintf("getfiletype(): unknown file type\n");

  return(FUNKNOWN);
}
